/**
 * exValidation
 *
 * @version   : 1.2.4
 * @author    : nori (norimania@gmail.com)
 * @copyright : 5509 (http://5509.me/)
 * @license   : The MIT License
 * @link      : http://5509.me/log/exvalidation
 * @modified  : 2011-06-21 15:17
 */
;(function($) {
	// Extend validation rules
	$.exValidationRules = $.extend($.exValidationRules, {
		chkrequired: [
			"͂Ă",
			function(txt, t) {
				if ( $(t).hasClass("chkgroup") ) {
					var flag = 0;
					$("input,select",t).each(function() {
						if ( $(this).val().length > 0 ) flag++;
					});
					if ( txt && flag === $("input,select", t).length ) {
						if ( /^[ @\r\n\t]+$/.test(txt) ) {
							return false;
						} else {
							return true;
						}
					}
				} else {
					if ( txt && txt.length>0 ) {
						if ( /^[ @\r\n\t]+$/.test(txt) ) {
							return false;
						} else {
							return true;
						}
					}
				}
			}
		],
		chkselect: [
			"IĂ",
			function(txt, t) {
				if ( txt && txt.length>0 ) {
					if ( /^[ @\r\n\t]+$/.test(txt) ) {
						return false;
					} else {
						return true;
					}
				}
			}
		],
		chkretype: [
			"͓eقȂ܂",
			function(txt, t) {
				var elm = $("#" + $(t).attr("class").split("retype\-")[1].split(/\b/)[0]);
				if ( elm.hasClass("chkgroup") ) {
					var chktxt = $("input", elm), txt = $("input", t);
					for ( var i = 0, flag = false; i < chktxt.length; i++ ) {
						if ( chktxt[i].value === txt[i].value ) flag = true;
						else flag = false;
					}
					if ( flag ) return true;
				} else {
					return elm.val() == txt;
				}
			}
		],
		chkemail: [
			"[AhX̌`͂Ă",
			/^(?:[^\@]+?@[A-Za-z0-9_\.\-]+\.+[A-Za-z\.\-\_]+)*$/
		],
		chkhankaku: [
			"Sp͎gpł܂",
			/^(?:[a-zA-Z0-9@\;\:\[\]\{\}\|\^\=\/\!\*\`\"\#\$\+\%\&\'\(\)\,\.\-\_\?\\\s]*)*$/
		], //"
		chkzenkaku: [
			"Spœ͂Ă",
			/^(?:[^a-zA-Z0-9@\;\:\[\]\{\}\|\^\=\/\!\*\"\#\$\+\%\&\'\(\)\,\.\-\_\?\\\s]+)*$/
		], //"
		chkhiragana: [
			"Ђ炪Ȃœ͂Ă",
			/^(?:[-[`]+)*$/
		],
		chkkatakana: [
			"J^Jiœ͂Ă",
			/^(?:[A-[`]+)*$/
		],
		chkfurigana: [
			"ӂ肪Ȃ͂Ђ炪ȁASp?A[Aijpł܂",
			/^(?:[-O-X[`ij\(\)\d @]+)*$/
		],
		chknochar: [
			"pœ͂Ă",
			/^(?:[a-zA-Z0-9]+)*$/
		],
		chknocaps: [
			"p(̂)œ͂Ă",
			/^(?:[a-z0-9]+)*$/
		],
		chknumonly: [
			"p݂̂œ͂Ă",
			/^(?:[0-9]+)*$/
		],
		chkmin: [
			"ȏœ͂Ă",
			function(txt, t) {
				if ( txt.length === 0 ) return true;
			 	var length = $(t).attr("class").match(/min(\d+)/) ? RegExp.$1 : null;
				return txt.length >= length;
			}
		],
		chkmax: [
			"ȓœ͂Ă",
			function(txt, t) {
				var length = $(t).attr("class").match(/max(\d+)/) ? RegExp.$1 : null;
				return txt.length <= length;
			}
		],
		chkradio: [
			"IĂ",
			function(txt, t) {
				return $("input:checked",t).length>0;
			}
		],
		chkcheckbox: [
			"IĂ",
			function(txt, t) {
				return $("input:checked",t).length>0;
			}
		],
		chkurl: [
			"URĽ`͂Ă",
			/^(?:http(s)?\:\/\/[^\/]*)*$/
		],
		chktel: [
			"dbԍ͂Ă",
			/^(?:\(?\d+\)?\-?\d+\-?\d+)*$/
		],
		chkfax: [
			"t@bNXԍ͂Ă",
			/^(?:\(?\d+\)?\-?\d+\-?\d+)*$/
		],
		chkfile: [
			"t@CIĂ",
			function(txt, t) {
				if ( txt && txt.length>0 ) {
					if ( /^[ @\r\n\t]+$/.test(txt) ) {
						return false;
					} else {
						return true;
					}
				}
			}
		]
	});
})(jQuery);